=encoding utf8

=head1 NAME

Mail::Message::Body::Delayed - body of a Mail::Message but not read yet.

=head1 INHERITANCE

 Mail::Message::Body::Delayed realizes a Mail::Message::Body

 Mail::Message::Body::Delayed
   is a Mail::Reporter

 Mail::Message::Body::Delayed
   is a Mail::Reporter

=head1 SYNOPSIS

  See Mail::Message::Body

=head1 DESCRIPTION

Message bodies of this type will be replaced by another type the moment you
access the content.  In this documentation you will find the description of
how a message body gets delay loaded.

Extends L<"DESCRIPTION" in Mail::Reporter|Mail::Reporter/"DESCRIPTION">.

=head1 OVERLOADED

=over 4

=item overload: B<""> stringification

Returns the body as string --which will trigger completion-- unless called
to produce a string for C<Carp>.  The latter to avoid deep recursions.

» example: stringification of delayed body

  print $msg->body;   # implicit by print

  my $body = $msg->body;
  my $x    = "$body"; # explicit by interpolation

=item overload: B<@{}> access as ARRAY

When a body object is used as being an array reference, the lines of
the body are returned.  This is the same as using the C<lines> method.

=item overload: B<bool> existence

Always returns a C<true> value, which is needed to have overloaded
objects to be used as in C<if($body)>.  Otherwise, C<if(defined $body)>
would be needed to avoid a runtime error.

=back

=head1 METHODS

Extends L<"METHODS" in Mail::Reporter|Mail::Reporter/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Reporter|Mail::Reporter/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Reporter/"Constructors">

 -Option --Default
  message  <required>

=over 2

=item message => MESSAGE

The MESSAGE object which contains this delayed body.

=back

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Reporter|Mail::Reporter/"Attributes">.

=head2 Error handling

Extends L<"Error handling" in Mail::Reporter|Mail::Reporter/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Reporter|Mail::Reporter/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head2 The body

=over 4

=item $obj-E<gt>B<message>()

Z<>

=back

=head2 About to the payload

=over 4

=item $obj-E<gt>B<guessSize>()

Z<>

=item $obj-E<gt>B<isDelayed>()

Z<>

=item $obj-E<gt>B<isModified>()

Z<>

=item $obj-E<gt>B<isMultipart>()

Z<>

=item $obj-E<gt>B<modified>()

Z<>

=item $obj-E<gt>B<nrLines>()

Z<>

=back

=head2 Internals

=over 4

=item $obj-E<gt>B<fileLocation>( [$begin, $end] )

Z<>

=item $obj-E<gt>B<load>()

Returns the loaded version of this body.

=item $obj-E<gt>B<moveLocation>($distance)

Z<>

=item $obj-E<gt>B<read>($parser, $head, $bodytype)

Z<>

=back

=head1 DIAGNOSTICS

=over 4

=item Error: a message must be specified to a delayed body.

Cast by C<new()>

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=back

=head1 SEE ALSO

This module is part of Mail-Box version 4.01,
built on December 13, 2025. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2025 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

